C#调用AutoCAD二次开发

转载自百度文库https://wenku.baidu.com/view/51f742f8c8d376eeaeaa31c2.html

今天在c#中实现了对AutoCAD的调用,中间遇到了一些问题,现在记下来,希望对大家有点帮助。

参考文献来源:http://www.knowsky.com/3391.html 根据文章里讲的:
第一步:建立一C#的windows应用程序,
第二步:添加AutoCAD 2008 Type Library的引用, 第三步:根据文章里的内容写程序。
这些都没问题,但是编译时,出现“使用了未添加的引用程序集”的错误,然后在安装文件中找到“AUTODESK.AUTOCAD.INTEROP.COMMON.DLL”文件,再次添加引用,OK,程序正常运行。
例子程序实现了在c#中输入点,在CAD中完成划线的功能。
方便大家,将文献引入如下:
众所周知,对AutoCAD进行二次开发用到的主要工具有:ObjectArx,VBA,VLisp。但它们 的优缺点是显而易见的:ObjectArx功能强大,编程效率高,但它的缺点是编程者必须掌握VC++,而这门语言非常的难学;VBA和VLisp虽然简 单易上手,但它们对于开发大型的程序好象无能为力。那究竟有没有一种语言能结合它们的优点而尽量避免它们的缺点呢? 回答是肯定的,那就是微软新推出的21世纪编程语言C#。关于C#的详细介绍,大家可以参考有关的文章。  
  C#是通过AutoCAD ActiveX 这座桥梁来和AutoCAD之间进行通讯的。AutoCAD ActiveX 使用户能够从 AutoCAD 的内部或外部以编程方式来操作 AutoCAD。它是通过将 AutoCAD 对象显示到“外部世界”来做到这一点的。一旦这些对象被显示,许多不同的编程语言和环境就可以访问它们。关于AutoCAD ActiveX 的情况,大家可以参考AutoCAD自带的帮助。 呵呵,说了这么多无聊的,还是让我们通过一个具体的例子来说明怎样利用C#进行AutoCAD的二次开发吧。在介绍例子之前先讲一下有关的配置: (1)Visual Studio .net (2003和2002都可以,我用的是2002)  
(2)AutoCAD2000以上版本(我用的是2004)
这个例子非常简单,就是通过C#建立的窗体来启动AutoCAD并画一条直线。下面是编程的具体步骤:
(1)通过Visual Studio .net 建立一C#的windows应用程序。
(2) 在“解决方案资源管理器”中右击“引用”标签,在弹出的菜单中选择“添加引用”,在“添加引用”对话框中选择“com"选项卡下的下拉列表框中的 “AutoCAD 2004 Type Library"项(注意:不同版本的CAD的数字不同),单击右边的“选择”按钮,最后单击下面的“确定”按钮。
(3)在C#窗体中加入两个文本框和一个按钮,分别用于输入直线起点、终点的坐标和在CAD中画直线。下面主要解释一下添加的代码。
(a)在程序的开头加入:using AutoCAD;//导入AutoCAD引用空间
(b)在窗体的变量声明部分加入: private AcadApplication a;//声明AutoCAD对象 (c)在窗体的构造函数部分加入:a=new AcadApplicationClass();//创建AutoCAD对象                     a.Visible=true;//使AutoCAD可见 (d)在按钮的消息处理函数中加入:
double[] startPoint=new double[3]; //声明直线起点坐标
double[] endPoint=new double[3];//声明直线终点坐标
string[] str=textBox1.Text.Split(',');//取出直线起点坐标输入文本框的值,文本框的输入模式为"x,y,z"
for(int i=0;i<3;i++)
startPoint[i]=Convert.ToDouble(str[i]);//将str数组转为double型  str=textBox2.Text.Split(',');//取出直线终点坐标输入文本框的值 for(int i=0;i<3;i++)
endPoint[i]=Convert.ToDouble(str[i]);
a.ActiveDocument.ModelSpace.AddLine(startPoint,endPoint);//在AutoCAD中画直线 a.Application.Update();//更新显示
好了,简单吧,你可以试着编译一下。关于上面一些语句的用法,我会在下一讲中作详细介绍。  

大家好,今天我继续给各位介绍利用C#进行AutoCAD的二次开发。在这一讲中,主要介绍上一讲例子中存在的问题。  
         在上一次的例子中我是通过引用AutoCAD 2004 Type Library来进行C#与AutoCAD之间的通信,但这种方法存在两个致命的缺点。第一个缺点是每次调试程序的时候C#都要重新启动AutoCAD, 如果调试的次数非常多(比如跟踪错误然后调试),那么编程的效率就很低,因为启动一次CAD还是需要较长的时间。相对于第一个缺点,第二个缺点则更要命。 由于.NET本身的问题,Interop.AutoCAD.dll文件(就是通过它才实现了C#与AutoCAD之间的通信)存在着一些bug,因此虽然 有时你的代码是完全正确的,但C#编译器还是抛出莫名其妙的错误。那不是完蛋了吗?我曾经有一阶段就因为这两个要命的东东差一点放弃了C#而想改学 ObjectArx了,呵呵,不过还是运气好,我偶尔一次在网上看了一篇外国人写的文章,他专门介绍了这两个问题的解决办法。下面就来解决这两个问题。  
         首先来看第二个难题,按以下步骤来进行:
 
1.        随便用Visual Studio .NET建立一个C#应用程序,然后按照上一篇文章中的设置加入AutoCAD 2004 Type Library,然后不加入任何代码,编译你的程序。  
2.        在Visual Studio .NET命令行工具下用ildasm.exe(这个工具可以在Visual Studio .NET安装光盘中找到)把Interop.AutoCAD.dll文件(这个文件在步骤1中生成的项目的Bin\Release文件夹中)编译成中间语 言Interop. AutoCAD.il。注意:在步骤1中建立的项目的编译设置为Release模式。  
    ildasm.exe /source Interop.AutoCAD.dll /output=Interop. AutoCAD.il  
    又要注意了:把ildasm.exe,Interop.AutoCAD.dll放在同一目录下。  3.在记事本中打开Interop. AutoCAD.il文件,然后查找结尾是“SinkHelper”而开头为 ".class
private auto ansi sealed _DAcad“的语句,把语句中的private 改为public,然后保存Interop. AutoCAD.il文件。  4.使用ilasm.exe把Interop. AutoCAD.il文件编译为Interop.AutoCAD.dll文件,同样是在Visual Studio .NET命令行工具下进行。  
    ilasm.exe /resource=Interop.AutoCAD.res
/dll
Interop.AutoCAD.il
/output=Interop.
AutoCAD.dll  
Interop.AutoCAD.res文件是在步骤1中生成的。  
5.显然你不愿意每次编写应用程序时都通过上一篇文章中介绍的方法来加入Interop. AutoCAD.dll,那太麻烦了。你可以用下面的方法来让程序自动加入该文件:找到C:\Program Files\Microsoft.NET\ Primary Interop Assemblies 文件夹,然后把上面生成的  
Interop.AutoCAD.dll文件拷贝进去。      
 
       好了,第二个问题解决了,接下来看第一个。  
       在VBA中,编程者可以使用GetObject函数来获得当前活动的AutoCAD对象,但在C#中却没有,为了这个函数我几乎把MSDN给翻遍了,然后 去各种C#论坛问各位高手,结果都没得到解决,呵呵,可能国内使用C#的人比较少吧。还是在老外的论坛上看到了一篇就是讲这个问题的文章才把这个难题给解 决了。使用下面的语句就可以获得当前活动的AutoCAD对象了:  
   (AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.16")  
     (对于CAD2000和CAD2002,则把16改为15)  
当然以上语句必须在AutoCAD打开的情况下才能使用,否则会发生错误,对于AutoCAD没打开的情况,可以使用上一篇文章的方法来处理。完整的连接AutoCAD与C#的源程序如下所示:  
using System;  
using AutoCAD;  
using System.Runtime.InteropServices;  
namespace AcadExample  
{  
   public class AutoCADConnector : IDisposable
{  
      private AcadApplication _application;  
      private bool _initialized;  
      private bool _disposed;  
      public AutoCADConnector()        {  
         try  
         {
 
            // Upon creation, attempt to retrieve running instance  
            _application=
(AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.16");  
         }  
         catch  
         {  
            try  
            {  
               // Create an instance and set flag to indicate this  
               _application = new AcadApplicationClass();  
               _initialized = true;  
            }  
            catch  
            {  
    throw;  
            }  
         }  
      }
 
      // If the user doesn't call Dispose, the  
      // garbage collector will upon destruction  
      ~AutoCADConnector()        {  
         Dispose(false);  
      }   
      public AcadApplication Application  
      {  
         get  
         {  
            // Return our internal instance of AutoCAD  
            return _application;  
         }  
      }  
               
      // This is the user-callable version of Dispose.  
      // It calls our internal version and removes the  
      // object from the garbage collector's queue.
public void Dispose()  
      {  
         Dispose(true);  
         GC.SuppressFinalize(this);        }   
      // This version of Dispose gets called by our  
      // destructor.  
      protected virtual void Dispose(bool disposing)  
      {
 
         // If we created our AutoCAD instance, call its  
         // Quit method to avoid leaking memory.  
         if(!this._disposed && _initialized)  
            _application.Quit();  
             
         _disposed = true;                }     }  }
 
利用Visual Studio.net 把上面的程序编译成一个类库,你就可以在以后的程序中使用它了,下面的这个例子说明了它的用法。(首先把AcadExample类库包含在项目中)  
using System;  
using AcadExample;
using AutoCAD;  
namespace ConsoleApplication6  {  
   class Class1     {  
      [STAThread]
 
      static void Main(string[] args)  
      {
 
         using (AutoCADConnector connector = new AutoCADConnector())  
         {  
            Console.WriteLine(connector.Application.ActiveDocument.Name);  
         }  
         Console.ReadLine();        }     }  }
 
这个例子是在C#窗口中显示AutoCAD中当前文档的标题。
 
这一讲的主要内容是介绍AutoCAD对象模型,如果你对VBA开发AutoCAD了解的话,这部分内容应该是超简单的。
对象是 AutoCAD ActiveX 接口的主要构造块,每一个显示的对象均精确代表一个 AutoCAD 组件。AutoCAD ActiveX 接口的主要对象有: • 直线、圆弧、文字和标注等图形对象。 • 线型与标注样式等样式设置对象  • 图层、编组和块等组织结构对象  • 视图与视口等图形显示对象。  
• 图形、AutoCAD 应用程序本身也是对象
所有对象的根对象是AutoCAD 应用程序本身,它用AcadApplication类来表示。获得当前运行的AcadApplication对象可以使用上一讲中介绍的方法来得到。AcadApplication对象下有四个子对象构成,分别是:  
 AcadPreferences 对象,通过此对象可以访问和设置“选项”对话框中的相关选项  AcadDocuments对象,它表示AutoCAD 图形  AcadMenuBar 对象,它表示AutoCAD主菜单栏 (注意不是AcadMenuBars,因为应用程序只有一个主菜单栏)  AcadMenuGroups对象, 它表示AutoCAD 菜单和工具栏
上面介绍了AutoCAD ActiveX 接口对象模型的大致组成,下面重点介绍AcadDocuments对象,因为大部分的编程都与它有关。首先大家看到它是复数的形式,因此它是当前打开的AutoCAD所有图形的集合,这种对象称为集合对象(呵呵,好像在讲废话)。集合对象有一些比较重要的方法和特性。其中最主要的是:Count特性用于获取集合中的对象个数(从零开始);Item 方法用于获取集合中的任何对象。关于它们的用法我会在下面的例子中介绍。而 AcadDocuments的单数形式AcadDocument表示当前打开的一个AutoCAD图形。AcadDocument对象由以下几个主要对象组成:
 AcadModelSpace 集合和 AcadPaperSpace集合,提供对图形对象(直线、圆、等)的访问  AcadLayers、AcadLinetypes 和 AcadTextStyles,则提供对非图形对象(图层、线型、文本样式等)的访问
 AcadPlot 对象提供对“打印”对话框中设置的访问,并为应用过程提供了打印图形的各种方法
 AcadUtility 对象提供用户输入和转换函数
图形对象的创建使用Add方法,比如要创建一个圆,就是用AddCircle方法,而非图形对象的创建使用Add方法。
下面通过一个简单的例子来说明上面介绍的内容。这个例子是在AutoCAD中建立一个新的层,然后在该层中画一个红色的圆和一条绿色的直线。这是程序的源代码:(请先把上一讲中生成的interop.AutoCAD.dll 和 AutoCADExample.dll文件包含在工程中) using System;
using AcadExample; using AutoCAD;  
namespace CircleLine { ///  
/// Class1 的摘要说明。 ///  class Class1 { ///  
/// 应用程序的主入口点。 ///  
[STAThread]
static void Main(string[] args) {
//
// TODO: 在此处添加代码以启动应用程序 //
using(AutoCADConnector connector=new AutoCADConnector()) //连接AutoCAD {
AcadDocument aDocument=connector.Application.ActiveDocument;  //取得当前AutoCAD活动图形对象
double[] center=new Double[3]{20,20,0};//设置圆心 double radius=20;//设置圆的半径
double[] startPoint=new Double[3]{0,0,0};//设置直线的起点 double[] endPoint=new Double[3]{40,40,0};//设置直线的终点 AcadLayer newLayer=aDocument.Layers.Add("CircleLine"); //创建一个名为CircleLine的新层
aDocument.ActiveLayer=newLayer;//把CircleLine层设置为当前层
AcadCircle circle=aDocument.ModelSpace.AddCircle(center,radius);//加入圆 AcadLine line=aDocument.ModelSpace.AddLine(startPoint,endPoint);//加入直线 circle.color=ACAD_COLOR.acRed;//把圆变为红色 line.color=ACAD_COLOR.acGreen;//把直线变为绿色 connector.Application.Update();//更新显示
for(int i=0;i Console.WriteLine("这是第{0}个对象:{1}",i+1,aDocument.ModelSpace.Item(i)); //遍历当前图形   }
Console.ReadLine(); } } }
好了,今天就到这里。







阅读更多
换一批

没有更多推荐了,返回首页